%if 0%{?el7}
%define dist .el7
%endif

%{!?_unitdir: %global _unitdir /lib/systemd/system}
%{!?_tmpfilesdir:%global _tmpfilesdir %{_prefix}/lib/tmpfiles.d}

Epoch: 8
Summary: Intrusion Detection System
Name: suricata
Version: 3.1.1
Release: 1%{?dist}
License: GPLv2
Group: Applications/Internet
URL: http://suricata-ids.org
Source0: http://www.openinfosecfoundation.org/download/%{name}-%{version}.tar.gz
Source1: suricata.service
Source2: suricata.sysconfig
Source3: suricata.logrotate
Source4: fedora.notes
Source5: suricata-tmpfiles.conf
Source6: suricata.init
Source7: http://www.openinfosecfoundation.org/download/%{name}-%{version}.tar.gz.sig
# Make suricata use PIE
Patch1:  suricata-3.0.1-flags.patch
# liblua is not named correctly
Patch2:  suricata-3.0.1-lua.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: libyaml-devel
BuildRequires: libnfnetlink-devel libnetfilter_queue-devel libnet-devel
BuildRequires: zlib-devel libpcap-devel pcre-devel libcap-ng-devel
BuildRequires: file-devel nspr-devel nss-devel nss-softokn-devel
BuildRequires: jansson-devel GeoIP-devel python-devel
BuildRequires: git lua-devel
%if 0%{?fedora}
BuildRequires: coccinelle
%endif
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
BuildRequires: systemd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
%else
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
%endif
# Remove when rpath issues are fixed
BuildRequires: autoconf automake libtool

Packager:       momo-i <webmaster@momo-i.org>
Vendor:         momo-i, http://www.momo-i.org/

%description
The Suricata Engine is an Open Source Next Generation Intrusion
Detection and Prevention Engine. This engine is not intended to
just replace or emulate the existing tools in the industry, but
will bring new ideas and technologies to the field. This new Engine
supports Multi-threading, Automatic Protocol Detection (IP, TCP,
UDP, ICMP, HTTP, TLS, FTP and SMB! ), Gzip Decompression, Fast IP
Matching and coming soon hardware acceleration on CUDA and OpenCL
GPU cards.

%package sc
Summary:	Client for Suricata unix socket
Group:		Development/Tools
Requires:	python-simplejson
Requires:	%{name}
Conflicts:	%{name} < 1.4.1-3

%description sc
%{summary}.

%package file_processor
Summary:	File processor for suricata
Group:		Development/Tools
Requires:	%{name}
Requires:	perl(Moose)
Requires:	perl(Module::Pluggable)
Requires:	perl(Log::Log4perl)
Requires:	perl(Config::JSON)
Requires:	perl(File::Tail)
Requires:	perl(LWP::UserAgent)
Requires:	perl(Sys::Syslog)
BuildArch:	noarch

%description file_processor
%{summary}.

%prep
%setup -q
install -m 644 %{SOURCE4} doc/
%patch1 -p1
%patch2 -p1
# This is to fix rpaths created by bad Makefile.in
autoreconf -fv --install

%build
%configure --enable-gccprotect \
	--disable-gccmarch-native \
	--enable-old-barnyard2 \
	--enable-nfqueue \
	--enable-af-packet \
	--with-libnspr-includes=/usr/include/nspr4 \
	--with-libnss-includes=/usr/include/nss3 \
	--enable-lua \
	--enable-geoip \
%if 0%{?rhel}
	--disable-coccinelle \
%endif
	--enable-jansson

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR="${RPM_BUILD_ROOT}" "bindir=%{_sbindir}" install

# Setup etc directory
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/suricata/rules
install -m 600 suricata.yaml $RPM_BUILD_ROOT%{_sysconfdir}/suricata
install -m 600 classification.config $RPM_BUILD_ROOT%{_sysconfdir}/suricata
install -m 600 reference.config $RPM_BUILD_ROOT%{_sysconfdir}/suricata
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
mkdir -p $RPM_BUILD_ROOT%{_unitdir}
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_unitdir}/
mkdir -p %{buildroot}%{_tmpfilesdir}
install -m 0644 %{SOURCE5} %{buildroot}%{_tmpfilesdir}/%{name}.conf
%else
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -D -m 0755 %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/suricata
%endif
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -m 0755 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/suricata
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/suricata
install -m 644 threshold.config $RPM_BUILD_ROOT%{_sysconfdir}/suricata/threshold.config
touch $RPM_BUILD_ROOT%{_sysconfdir}/suricata/rules/local.rules

# Make logging directory
mkdir -p $RPM_BUILD_ROOT/%{_var}/log/suricata

# Remove a couple things so they don't get picked up
rm -rf $RPM_BUILD_ROOT%{_includedir}
rm -f $RPM_BUILD_ROOT%{_libdir}/libhtp.la
rm -f $RPM_BUILD_ROOT%{_libdir}/libhtp.a
rm -f $RPM_BUILD_ROOT%{_libdir}/libhtp.so
rm -rf $RPM_BUILD_ROOT%{_libdir}/pkgconfig
rm -rf $RPM_BUILD_ROOT%{_docdir}/%{name}

pushd contrib/file_processor
mv -f LICENSE ../../doc/LICENSE.file_processor
mv -f README ../../doc/README.file_processor
install -d -m 0755 $RPM_BUILD_ROOT%{_sysconfdir}/suricata/file_processor/
install -D -m 0644 file_processor.conf $RPM_BUILD_ROOT%{_sysconfdir}/suricata/file_processor/file_processor.conf
install -D -m 0755 file_processor.pl $RPM_BUILD_ROOT%{_sysconfdir}/suricata/file_processor/file_processor.pl
cp -rp Action $RPM_BUILD_ROOT%{_sysconfdir}/suricata/file_processor/
cp -rp Processor/ $RPM_BUILD_ROOT%{_sysconfdir}/suricata/file_processor/
find $RPM_BUILD_ROOT%{_sysconfdir}/suricata/file_processor/ -name 'Makefile*' | xargs rm -f 
popd

%check
make check

%clean
rm -rf $RPM_BUILD_ROOT

%post
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
#systemd_post suricata.service
if [ $1 -eq 1 ] ; then
	# Initial installation
	systemctl preset %{name}.service >/dev/null 2>&1 || :
fi
%else
/sbin/chkconfig --add suricata
/sbin/ldconfig
%endif

%preun
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
#systemd_preun suricata.service
if [ $1 -eq 0 ] ; then
	# Package removal, not upgrade
	systemctl --no-reload disable %{name}.service > /dev/null 2>&1 || :
	systemctl stop %{name}.service > /dev/null 2>&1 || :
fi
%else
if [ $1 -eq 0 ]; then
	/sbin/service suricata stop > /dev/null 2>&1
	/sbin/chkconfig --del suricata
fi
%endif

%postun
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
#systemd_postun_with_restart suricata.service
systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
	# Package upgrade, not uninstall
	systemctl try-restart %{name}.service >/dev/null 2>&1 || :
fi
%else
/sbin/ldconfig
%endif

%files
%defattr(-,root,root,-)
%doc doc/INSTALL doc/Basic_Setup.txt
%doc doc/Setting_up_IPSinline_for_Linux.txt doc/fedora.notes
%{!?_licensedir:%global license %%doc}
%license COPYING
%{_sbindir}/suricata
%{_libdir}/libhtp-*
%attr(750,root,root) %dir %{_var}/log/suricata
%config(noreplace) %{_sysconfdir}/suricata/suricata.yaml
%config(noreplace) %{_sysconfdir}/suricata/classification.config
%config(noreplace) %{_sysconfdir}/suricata/reference.config
%dir %attr(750,root,root) %{_sysconfdir}/suricata
%dir %attr(750,root,root) %{_sysconfdir}/suricata/rules
%config(noreplace) %attr(0600,root,root) %{_sysconfdir}/sysconfig/suricata
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7
%attr(644,root,root) %{_unitdir}/suricata.service
%attr(644,root,root) %{_tmpfilesdir}/%{name}.conf
%else
%attr(755,root,root) %{_sysconfdir}/rc.d/init.d/suricata
%endif
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/logrotate.d/suricata
%config(noreplace) %{_sysconfdir}/suricata/threshold.config
%config(noreplace) %{_sysconfdir}/suricata/rules/local.rules

### TEST
%files sc
%{_bindir}/suricatasc
/usr/lib/python*/site-packages/suricatasc*

%files file_processor
%{_sysconfdir}/suricata/file_processor/*

%changelog
* Thu Aug 11 2016 momo-i <webmaster@momo-i.org> - 8:3.1.1-1
- Update to 3.1.1

* Sun Jun 26 2016 momo-i <webmaster@momo-i.org> - 8:3.1-1
- Update to 3.1

* Mon Apr 18 2016 momo-i <webmaster@momo-i.org> - 8:3.0.1-1
- Update to 3.0.1
- rebase patch to 3.0.1

* Wed Feb 03 2016 momo-i <webmaster@momo-i.org> - 8:3.0-1
- Update to 3.0

* Sun Jan 03 2016 momo-i <webmaster@momo-i.org> - 8:2.0.11-1
- Update to 2.0.11

* Wed Dec 09 2015 momo-i <webmaster@momo-i.org> - 8:2.0.10-1
- Update to 2.0.10

* Mon Sep 28 2015 momo-i <webmaster@momo-i.org> - 8:2.0.9-1
- Update to 2.0.9

* Thu Sep 17 2015 momo-i <webmaster@momo-i.org> - 8:2.0.8-6
- Change spec

* Thu Sep 03 2015 momo-i <webmaster@momo-i.org> - 8:2.0.8-5
- Update dist for centos7

* Mon Aug 10 2015 momo-i <webmaster@momo-i.org> - 8:2.0.8-4
- Rebuilt for fc23

* Mon May 11 2015 momo-i <webmaster@momo-i.org> - 2.0.8-3
- Update to 2.0.8

* Thu Apr 16 2015 momo-i <webmaster@momo-i.org> - 2.0.7-3
- Rebuilt for fc22

* Tue Mar 24 2015 momo-i <webmaster@momo-i.org> - 2.0.7-2
- Update to 2.0.7

* Tue Dec 16 2014 momo-i <webmaster@momo-i.org> - 2.0.5-2
- Update to 2.0.5

* Wed Nov 19 2014 momo-i <webmaster@momo-i.org> - 2.0.4-2
- Update some rc

* Fri Sep 26 2014 momo-i <webmaster@momo-i.org> - 2.0.4-1
- Update to 2.0.4

* Mon Jul 28 2014 momo-i <webmaster@momo-i.org> - 2.0.2-1
- Update to 2.0.2

* Tue Jan  7 2014 momo-i <webmaster@momo-i.org> - 1.4.7-1
- New upstream bug fix release

* Mon Oct  7 2013 momo-i <webmaster@momo-i.org> - 1.4.6-3
- Update to 1.4.6
- add geoip and jansson
- Drop prelude support

* Wed Aug 14 2013 momo-i <webmaster@momo-i.org> - 1.4.5-1
- Update to 1.4.5

* Fri May 31 2013 momo-i <webmaster@momo-i.org> 1.4.2-1
- Update 1.4.2

* Fri Mar 29 2013 momo-i <webmaster@momo-i.org> 1.4.1-3
- separate suricatasc

* Fri Mar 29 2013 momo-i <webmaster@momo-i.org> 1.4.1-1
- New upstream bugfix release
